import java.io.*;
import java.net.*;

public class Client {
    public static void main(String[] args) throws IOException {

        Socket kkSocket = null;
        PrintWriter out = null;
        BufferedReader in = null;

        try {
            kkSocket = new Socket("localhost", 4445);
            out = new PrintWriter(kkSocket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(kkSocket.getInputStream()));
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: localhost.");
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection to: localhost.");
            System.exit(1);
        }

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        String fromServer;
        String fromUser;
           
        while ((fromServer = in.readLine()) != null) {
            System.out.println("Rezultas: " + fromServer);
		    
            fromUser = stdIn.readLine();
            if (fromUser.equals("exit")){
                out.println(fromUser);
                System.out.println(in.readLine());
                break;
                } 
            else out.println(fromUser);
            
        }

        out.close();
        in.close();
        stdIn.close();
        kkSocket.close();
    }
}
