/* Nutoles kalkuliatorius
 * Darba atliko:  Tomas Juodeka
 * 2007 04 22   */

import java.net.*;
import java.io.*;

public class Server {
    public static void main(String[] args) throws IOException {

        /* sukuria serverio socketa per kuri klausomasi */
        ServerSocket serverSocket = null;
        try {
            serverSocket = new ServerSocket(4445);
        } catch (IOException e) {
            System.err.println("Could not listen on port: 4444.");
            System.exit(1);
        }

        System.out.println("Server is listening now");
        
        /* kai sekmingai ivyksta susijungimas gaunam kliento socketa.
         * per ji vyksta bendravimas tarp serverio ir kliento
         * ciklas nutraukiamas kai ivedama 'n' po kliento atsijungimo */
        
        while(true) {
            Socket clientSocket = null;
            try {
                clientSocket = serverSocket.accept();
            } catch (IOException e) {
                System.err.println("Accept failed.");
                System.exit(1);
            }
        
            System.out.println("Connection with the client established");
        
            /* Objektas out skirtas atspausdinti zinute cliento programoj,
               in gauna tai ka atsiuncia klientas */
            
            PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
            BufferedReader in = new BufferedReader( new InputStreamReader(
                                    clientSocket.getInputStream()));
    
            out.println("Programa skaiciuoja tik pagrindines " +
                         "f-jas: +, -, *, /" +
                         "Naudojimas: [Op1][op zenklas][Op2]"); 
            String inputLine;
            DoStuff ds = new DoStuff();
            
            /* ciklas i kuri idetas benravimas su cliento. Iki kol neiveda 'exit' */
            while( !((inputLine = in.readLine()).equals("exit")) ) {
                boolean klaida = false;
               // if (inputLine == "exit")
                 //   break;
                /* Patikrinam ar vartotojas neivede tarpu ir raidziu */
                for(int i = 0; i < inputLine.length(); i++) {
                    if ((Character.isWhitespace(inputLine.charAt(i))) || (
                            Character.isLetter(inputLine.charAt(i)))) {
                        klaida = false;
                        out.println("Ivesti netinkami duomenys");
                        break;
                    }
                    else 
                        klaida = true;
                }
                if(klaida) {
                    float rez = ds.ctoi(inputLine);
                    out.println(rez);
                } else {
                    out.println("Ivesti netinkami duomenys");
                    continue;
                }
               /* for (int i = 0; i < inputLine.length()-1; i++) {
                    if (!(Character.isWhitespace(inputLine.charAt(i)))) {
                        System.out.println("Gaidys");
                        float rez = ds.ctoi(inputLine);
                        out.println(rez);
                    } 
                    else {
                        out.println("Ivesti netinkami duomenys");
                        break;
                    }
                }*/
            }
            out.println("bye");
            out.close();
            in.close();
            clientSocket.close();
            System.out.println("Connection with client is broken");
            
            /* Susikuriu objekta cin nuskaityt viena simboli is comandines eilutes */
            InputStreamReader cin = new InputStreamReader(System.in);
            System.out.println("Do you want to proceed?\n Enter y/n");
            if(cin.read() == 'n')
                break;
            else System.out.println("Server is listening now");
        }
        serverSocket.close();
    }
}
